/*
 * ExampleAssistant.cpp
 *
 *  Created on: 27.03.2010
 *      Author: emanoil
 *
 * example-editor Copyright (C) 2009 example-editor development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "ExampleAssistant.h"
//can be used to call it from external app
//ExampleAssistant* do_start() {
//	return new ExampleAssistant();
//}
/** Constructor
  *  - initialize width, hight and name
  */

ExampleAssistant::ExampleAssistant():
m_width(480),
m_height(320),
m_name("ExampleAssistant")
{
	// TODO Auto-generated constructor stub
	initAttributes();
}

/** Destructor
  *  - remove all pages
  */
ExampleAssistant::~ExampleAssistant() {
	// TODO Auto-generated destructor stub
	std::list<Widget*>::iterator iter = m_pages.begin();

	while (iter != m_pages.end()) {
		delete *iter;
		iter++;
	}
}

// Private attribute accessor methods
//


/**
 * Set the value of m_width
 * @param new_var the new value of m_width
 */
void ExampleAssistant::setWidth ( unsigned int new_var ) {
  m_width = new_var;
}

/**
 * Get the value of m_width
 * @return the value of m_width
 */
unsigned int ExampleAssistant::getWidth ( ) {
  return m_width;
}

/**
 * Set the value of m_height
 * @param new_var the new value of m_height
 */
void ExampleAssistant::setHeight ( unsigned int new_var ) {
  m_height = new_var;
}

/**
 * Get the value of m_height
 * @return the value of m_height
 */
unsigned int ExampleAssistant::getHeight ( ) {
  return m_height;
}

///**
// * Set the value of m_pages
// * @param new_var the new value of m_pages
// */
//void ExampleAssistant::setPages ( list<Gtk::Widget *> new_var ) {
//  m_pages = new_var;
//}

///**
// * Get the value of m_pages
// * @return the value of m_pages
// */
//list<Gtk::Widget *> ExampleAssistant::getPages ( ) {
//  return m_pages;
//}

/**
 * Set the value of m_name
 * @param new_var the new value of m_name
 */
void ExampleAssistant::setName ( std::string new_var ) {
  m_name = new_var;
}

// Other methods
//


/**
 * Get the value of m_name
 * @return the value of m_name
 */
std::string ExampleAssistant::getName ( ) {
  return m_name;
}

// Other methods
//

/**
 * Initializes all attributes
 * and builds the ExampleAssistant togeether
 */
void ExampleAssistant::initAttributes() {

    set_title( getName() );
    set_default_size( getWidth(), getHeight() );

    signal_cancel().connect(sigc::mem_fun(*this, &ExampleAssistant::on_cancel));
    signal_close().connect(sigc::mem_fun(*this, &ExampleAssistant::on_cancel));

    p_VBoxPage1 = new Gtk::VBox;
    p_VBoxPage2 = new Gtk::VBox;
    p_VBoxPage3 = new Gtk::VBox;

    m_Button1.set_label("This is page 1\nClick me to proceed!");
    m_Button2.set_label("This is page 2\nClick me to go forward!");
    m_Button3.set_label("This is page 3\nClick me to start over!");

    p_VBoxPage1->pack_end(m_Button1);
    m_Label1.set_text("New Name");
    p_VBoxPage1->pack_end(m_Label1);
    p_VBoxPage1->pack_end(m_Entry1);
    p_VBoxPage2->pack_end(m_Button2);
    p_VBoxPage3->pack_end(m_Button3);

    m_pages.push_back(p_VBoxPage1);
    m_pages.push_back(p_VBoxPage2);
    m_pages.push_back(p_VBoxPage3);

    append_page(*p_VBoxPage1);
    append_page(*p_VBoxPage2);
    append_page(*p_VBoxPage3);

    set_page_type (*p_VBoxPage1, Gtk::ASSISTANT_PAGE_INTRO);
    set_page_title(*p_VBoxPage1, "This is the intro page!");
    set_page_type (*p_VBoxPage2, Gtk::ASSISTANT_PAGE_CONTENT);
    set_page_title(*p_VBoxPage2, "This is the content");
    set_page_type (*p_VBoxPage3, Gtk::ASSISTANT_PAGE_SUMMARY);
    set_page_title(*p_VBoxPage3, "This is the summary");

    m_Button1.signal_clicked().connect(
                sigc::mem_fun(*this, &ExampleAssistant::on_intro_finished));
    m_Button2.signal_clicked().connect(
                sigc::mem_fun(*this, &ExampleAssistant::on_summary_finished));
    m_Button3.signal_clicked().connect(
                sigc::mem_fun(*this, &ExampleAssistant::on_confirm_finished));



#ifndef EXAMPLE_ASSISTANT_TEST
    hide_all();
#else
    show_all();
#endif

}

// Other methods


void ExampleAssistant::on_intro_finished(void) {
	// when the button is clicked we switch to the introduction page and
	// mark this as not completed. So the user has to click on the button
	// to complete
	set_page_complete(*p_VBoxPage1, true);
	set_current_page(1);
}

void ExampleAssistant::on_summary_finished(void) {
	set_page_complete(*p_VBoxPage2, true);
}

void ExampleAssistant::on_confirm_finished(void) {
	set_page_complete(*p_VBoxPage3, true);
	set_current_page(0);
}

void
ExampleAssistant::on_cancel(void) {
#ifndef EXAMPLE_ASSISTANT_TEST
       hide();
#else
	Gtk::Main::quit();
#endif
}
