/*
 * ExampleAssistant.h
 *
 *  Created on: 27.03.2010
 *      Author: emanoil
 *
 * example-editor Copyright (C) 2009 example-editor development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef EXAMPLEASSISTANT_H_
#define EXAMPLEASSISTANT_H_

#define EXAMPLE_ASSISTANT_TEST 1

#include <iostream>

#include <list>
#include <gtkmm.h>

//using namespace std;
/**
  * class ExampleAssistant
  */

class ExampleAssistant : public Gtk::Assistant {
public:
	ExampleAssistant();
	virtual ~ExampleAssistant();

	// Private attribute accessor methods
	//

	  /**
	   * Set the value of m_width
	   * @param new_var the new value of m_width
	   */
	  void setWidth ( unsigned int new_var );

	  /**
	   * Get the value of m_width
	   * @return the value of m_width
	   */
	  unsigned int getWidth ( );


	  /**
	   * Set the value of m_height
	   * @param new_var the new value of m_height
	   */
	  void setHeight ( unsigned int new_var );

	  /**
	   * Get the value of m_height
	   * @return the value of m_height
	   */
	  unsigned int getHeight ( );


//	  /**
//	   * Set the value of m_pages
//	   * @param new_var the new value of m_pages
//	   */
//	  void setPages ( list<Gtk::Widget *> new_var );

//	  /**
//	   * Get the value of m_pages
//	   * @return the value of m_pages
//	   */
//	  list<Gtk::Widget *> getPages ( );


	  /**
	   * Set the value of m_name
	   * @param new_var the new value of m_name
	   */
	  void setName ( std::string new_var );

	  /**
	   * Get the value of m_name
	   * @return the value of m_name
	   */
	  std::string getName ( );

	  /**
	   */
	virtual void on_intro_finished(void);
	  /**
	   */
	virtual void on_summary_finished(void);
	  /**
	   */
	virtual void on_confirm_finished(void);


private:
	  /**
	   */
	virtual void initAttributes ( ) ;

	  // Private attributes
	  //

	  unsigned int m_width;
	  unsigned int m_height;
	  std::string  m_name;

protected:
    // store the pages in a list so we can delete them later
	  std::list<Gtk::Widget*> m_pages;
	  Gtk::VBox   *p_VBoxPage1, *p_VBoxPage2, *p_VBoxPage3;
	  Gtk::Button m_Button1,   m_Button2,   m_Button3;
	  Gtk::Label  m_Label1;
	  Gtk::Entry  m_Entry1;

	  /**
	   */
	virtual void on_cancel(void);
};

#endif /* EXAMPLEASSISTANT_H_ */
